jQuery(document).ready(function() {
	
	////////////////////////////////////
	// Hide handlers
	////////////////////////////////////
	jQuery('#at_noti_alert_metabox .handlediv, #at_noti_alert_metabox .hndle').hide();
	
	// Tabs
	
	jQuery('.general_tabs li').click(function() {
		jQuery('.general_tabs li').removeClass('selected');
		jQuery(this).addClass('selected');
		
		var sect = jQuery(this).attr('data-section');
		jQuery('.general_opts > div').hide();
		jQuery('.general_opts .'+sect).show();
	});
	
	////////////////////////////////////
	// Start
	////////////////////////////////////
	
	
	var media_button_id;
	
	if (jQuery('#at_noti_alert_metabox').length) {
		
		jQuery('#pageparentdiv .inside > p:eq(0), #pageparentdiv .inside > select:eq(0)').hide();
		
		var at_noti_debug = 0;
		var file_frame;
		
		jQuery('#alert_visible_to').change(function() {
			if (jQuery('#alert_visible_to').val() == '1')
				jQuery('#visible_to_roles').fadeIn('fast');
			else 
				jQuery('#visible_to_roles').fadeOut('fast');
		}).change();
		
		jQuery('#alert_drop_shadow').change(function() {
			if (jQuery('#alert_drop_shadow').val() == '1')
				jQuery('#drop_shadow_options').fadeIn('fast');
			else 
				jQuery('#drop_shadow_options').fadeOut('fast');
		}).change();
		
		jQuery('#alert_border').change(function() {
			if (jQuery('#alert_border').val() == '1')
				jQuery('#border_options').fadeIn('fast');
			else 
				jQuery('#border_options').fadeOut('fast');
		}).change();
		
		
		
		
		jQuery('.at_noti_tipsy').tipsy({'gravity': 'se'});
		
		var reloadPreview = function(id) {
			if (at_noti_debug) console.log('triggered reloadPreview : '+id);
			
			id = typeof id !== 'undefined' ? id : null;
			
			////////////////////////////////////
			// Add # to all colors
			////////////////////////////////////
			jQuery('.color-picker').each(function() {
				if (jQuery(this).val().indexOf('#') === -1) {
					jQuery(this).val('#'+jQuery(this).val());
				}
			});
			
			////////////////////////////////////
			// height + width
			////////////////////////////////////
			jQuery('#at_noti_preview').css('height', jQuery('#at_noti_options_alert_height').val());
			jQuery('#at_noti_preview_content').css('height', jQuery('#at_noti_options_alert_height').val()-2);
			jQuery('#at_noti_preview_content').css('width', jQuery('#at_noti_options_alert_width').val());
			
			////////////////////////////////////
			// background
			////////////////////////////////////
			jQuery('#at_noti_preview').css('background', jQuery('#at_noti_options_bgcolor').val());
			var container_lines = getContrastYIQ(jQuery('#at_noti_options_bgcolor').val());
			jQuery('#at_noti_preview_content').css('border-color', container_lines);
			
			////////////////////////////////////
			// close button 
			////////////////////////////////////
			jQuery('#at_noti_preview_close_btn').css({
				'display': (jQuery('#at_noti_options_alert_close_btn').val() == 1 ? 'block' : 'none'),
				'color':	jQuery('#at_noti_options_alert_close_btn_color').val()
			}).html('<i class="'+jQuery('#at_noti_options_alert_close_btn_style').val()+'"></i>');
			
			////////////////////////////////////
			// drop shadow 
			////////////////////////////////////
			if (jQuery('#alert_drop_shadow').val() == 1) {
				jQuery('#at_noti_preview').css({
					'-moz-box-shadow': '0px 1px '+jQuery('#at_noti_options_drop_shadow_blur').val()+'px '+jQuery('#at_noti_options_drop_shadow_spread').val()+'px '+jQuery('#at_noti_options_drop_shadow_color').val(),
					'-webkit-box-shadow': '0px 1px '+jQuery('#at_noti_options_drop_shadow_blur').val()+'px '+jQuery('#at_noti_options_drop_shadow_spread').val()+'px '+jQuery('#at_noti_options_drop_shadow_color').val(),
					'box-shadow': '0px 1px '+jQuery('#at_noti_options_drop_shadow_blur').val()+'px '+jQuery('#at_noti_options_drop_shadow_spread').val()+'px '+jQuery('#at_noti_options_drop_shadow_color').val()
				});
			}
			else {
				jQuery('#at_noti_preview').css({
					'-moz-box-shadow': 'none',
					'-webkit-box-shadow': 'none',
					'box-shadow': 'none'
				});
			}
			
			////////////////////////////////////
			// border 
			////////////////////////////////////
			if (jQuery('#alert_border').val() == 1) {
				jQuery('#at_noti_preview').css({
					'border-bottom': 'solid '+jQuery('#at_noti_options_border_color').val()+' '+jQuery('#at_noti_options_border_size').val()+'px'
				});
			}
			else {
				jQuery('#at_noti_preview').css({
					'border': 'none'
				});
			}
			
			if (id == 'resize') {
				return;
			}
			
			////////////////////////////////////
			// Layers
			////////////////////////////////////
			if (id == null)
				var layers_to_reload = jQuery('.layer_row');
			else
				var layers_to_reload = jQuery('#at_layer_row_'+id);
			
			layers_to_reload.each(function() {
				var id = jQuery(this).attr('id').replace('at_layer_row_', '');
				var row = jQuery(this);
				var type = row.find('.at_noti_options_layer_type').val();
				var preview = jQuery('#at_noti_preview_content #at_noti_preview_layer_'+id);
				
				preview.attr('style', jQuery('#at_noti_options_alert_layer_css_inline_'+id).val());
				
				preview.css('right', 'auto');
				preview.css('left', 'auto');
				
				if (jQuery('#at_noti_options_layer_align_from_horiz_'+id).val() == 'left'){ 
					preview.css({
						'left' : jQuery('#at_noti_options_alert_layer_x_'+id).val()+'px'
					});
				}
				else {
					preview.css({
						'right' : jQuery('#at_noti_options_alert_layer_x_'+id).val()+'px'
					});
				}
				
				preview.css({
					'top': jQuery('#at_noti_options_alert_layer_y_'+id).val()+'px',
					'z-index': jQuery('#at_noti_options_alert_layer_z_'+id).val(),
					'line-height': '',
					'color': '',
					'font-family': '',
					'font-size': '',
					'width': '',
					'height': '',
					'border': 'none'
				}).html('');
				
				switch(type) {
					case 'caption':
						preview.html(jQuery('#at_noti_options_layer_text_'+id).val());
						preview.css({
							'color': jQuery('#at_noti_options_alert_layer_color_'+id).val(),
							'line-height': ((jQuery('#at_noti_options_alert_layer_line_height_'+id).val() > 0) ? jQuery('#at_noti_options_alert_layer_line_height_'+id).val()+'px' : ''),
							'font-size': jQuery('#at_noti_options_alert_layer_size_'+id).val()+'px',
							'font-family': "'"+((row.find('.at_noti_options_layer_font').val()) ? row.find('.at_noti_options_layer_font').val().replace(/\+/g, " ").split(':')[0] : 'Arial')+"'"
						});
						break;
					case 'icon':
						preview.html('<i class="'+jQuery('#at_noti_options_alert_icon_'+id).val()+'"></i>');
						preview.css({
							'color': jQuery('#at_noti_options_alert_layer_color_'+id).val(),
							'font-size': jQuery('#at_noti_options_alert_layer_size_'+id).val()+'px'
						});
						break;
					case 'image':
						preview.html('<img src="'+jQuery('#at_noti_options_alert_layer_img_url_'+id).val()+'">');
						preview.find('img').css({
							'height': ((jQuery('#at_noti_options_alert_layer_h_'+id).val()) ? jQuery('#at_noti_options_alert_layer_h_'+id).val()+'px' : 'auto'),
							'width': ((jQuery('#at_noti_options_alert_layer_w_'+id).val()) ? jQuery('#at_noti_options_alert_layer_w_'+id).val()+'px' : 'auto')
						});
						break;
					case 'button':
						preview.html(jQuery('#at_noti_options_alert_layer_btn_caption_'+id).val());
						preview.css({
							'color': jQuery('#at_noti_options_alert_layer_color_'+id).val(),
							'background': jQuery('#at_noti_options_alert_layer_color_btn_background_'+id).val(),
							'padding': jQuery('#at_noti_options_alert_layer_padding_'+id).val()+'px',
							'border-radius': jQuery('#at_noti_options_alert_layer_border_radius_'+id).val()+'px',
							'font-size': jQuery('#at_noti_options_alert_layer_size_'+id).val()+'px',
							'line-height': jQuery('#at_noti_options_alert_layer_size_'+id).val()+'px',
							'font-family': "'"+((row.find('.at_noti_options_layer_font').val()) ? row.find('.at_noti_options_layer_font').val().replace(/\+/g, " ").split(':')[0] : 'Arial')+"'"
						});
						break;
					case 'widget':
						preview.html('<span>WIDGET AREA</span>');
						preview.css({
							'display': 'table'
						});
						preview.find('span').css({
							'color': container_lines,
							'border-color': container_lines+'!important',
							'border-style': 'dotted',
							'border-width': '1px',
							'display': 'table-cell',
							'vertical-align': 'middle',
							'text-align': 'center',
							'height': ((jQuery('#at_noti_options_alert_layer_h_'+id).val()) ? jQuery('#at_noti_options_alert_layer_h_'+id).val()+'px' : 'auto'),
							'width': ((jQuery('#at_noti_options_alert_layer_w_'+id).val()) ? jQuery('#at_noti_options_alert_layer_w_'+id).val()+'px' : 'auto')
						});
						break;
				}
				
			});
			
			if (at_noti_debug) console.log('end reloadPreview');
		}
		jQuery(document).on('click', '#at_noti_preview_button', function() {
			reloadPreview();
		});
		
		
		////////////////////////////////////
		// Change alert title placeholder
		////////////////////////////////////
		if (jQuery('#title-prompt-text').length) { 
			jQuery('#title-prompt-text').html('Give your alert a Name here'); 
			//jQuery('#edit-slug-box').hide(); 
		}
		
		////////////////////////////////////
		// Sliders
		////////////////////////////////////
		jQuery('#at_noti_options_alert_height_slider').slider({
			min: 10,
			max: 600,
			slide: function(event, ui) {
				jQuery('#at_noti_options_alert_height').val(ui.value);
				reloadPreview();
			},
			value: jQuery('#at_noti_options_alert_height').val()
		});
		jQuery('#at_noti_options_alert_width_slider').slider({
			min: 300,
			max: 2000,
			slide: function(event, ui) {
				jQuery('#at_noti_options_alert_width').val(ui.value);
				reloadPreview();
			},
			value: jQuery('#at_noti_options_alert_width').val()
		});
		jQuery('#at_noti_options_alert_drop_shadow_blur_slider').slider({
			min: 0,
			max: 100,
			slide: function(event, ui) {
				jQuery('#at_noti_options_drop_shadow_blur').val(ui.value);
				reloadPreview();
			},
			value: jQuery('#at_noti_options_drop_shadow_blur').val()
		});
		jQuery('#at_noti_options_alert_drop_shadow_spread_slider').slider({
			min: 0,
			max: 100,
			slide: function(event, ui) {
				jQuery('#at_noti_options_drop_shadow_spread').val(ui.value);
				reloadPreview();
			},
			value: jQuery('#at_noti_options_drop_shadow_spread').val()
		});
		jQuery('#at_noti_options_alert_border_size').slider({
			min: 0,
			max: 10,
			slide: function(event, ui) {
				jQuery('#at_noti_options_border_size').val(ui.value);
				reloadPreview();
			},
			value: jQuery('#at_noti_options_border_size').val()
		});
		
		
		
		
		////////////////////////////////////
		// contrast calculator
		////////////////////////////////////
		function getContrastYIQ(hexcolor){
			hexcolor = hexcolor.replace('#', '');
			var r = parseInt(hexcolor.substr(0,2),16);
			var g = parseInt(hexcolor.substr(2,2),16);
			var b = parseInt(hexcolor.substr(4,2),16);
			var yiq = ((r*299)+(g*587)+(b*114))/1000;
			return (yiq >= 128) ? 'black' : 'white';
		}
		
		////////////////////////////////////
		// Alert Designer floater 
		////////////////////////////////////
		var at_designer_floater_offset = 	((jQuery('#wpadminbar').length) ? 40 : 12);
		var at_designer_floater_top = 		jQuery('#at_noti_alert_designer_floater').offset().top;
		var at_designer_floater_width = 	jQuery('#at_noti_alert_designer_floater').width();
		var at_designer_floater_height = 	0;
		
		jQuery(window).on('resize', function() {
			at_designer_floater_offset = 	((jQuery('#wpadminbar').length) ? 40 : 12);
			at_designer_floater_top = 		jQuery('#at_noti_alert_designer_floater').offset().top;
			at_designer_floater_width = 	jQuery('#at_noti_alert_designer_floater').width();
			at_designer_floater_height = 	jQuery('#at_noti_alert_designer_floater').height();
		});
		
		jQuery(window).scroll(function() {		
			at_designer_floater_height = jQuery('#at_noti_alert_designer_floater').height();
			
			if (jQuery(this).scrollTop() >= (at_designer_floater_top-at_designer_floater_offset)) {
				if (!jQuery('#at_noti_alert_designer_floater_placeholder').length) {
					jQuery('<div id="at_noti_alert_designer_floater_placeholder"></div>').insertBefore(jQuery('#at_noti_alert_designer_floater'));
					jQuery('#at_noti_alert_designer_floater_placeholder').css({'width': at_designer_floater_width, 'height': at_designer_floater_height});
				}
				jQuery('#at_noti_alert_designer_floater').css({'position': 'fixed', 'top': at_designer_floater_offset+'px', 'width': at_designer_floater_width, 'height': at_designer_floater_height, '-webkit-box-shadow': '0px 0px 6px 3px rgba(0, 0, 0, 0.1)', 'box-shadow': '0px 0px 6px 3px rgba(0, 0, 0, 0.1)'});
			}
			else {
				jQuery('#at_noti_alert_designer_floater').css({'position': '', '-webkit-box-shadow': 'none', 'box-shadow': 'none'});
				jQuery('#at_noti_alert_designer_floater_placeholder').remove();
			}
			
		});
		
		////////////////////////////////////
		// General layout options
		////////////////////////////////////
		jQuery('#at_noti_options_alert_height').change(function() {
			jQuery('#at_noti_preview').css('height', jQuery('#at_noti_options_alert_height').val());
			jQuery('#at_noti_preview_content').css('height', jQuery('#at_noti_options_alert_height').val()-2);
		});
		jQuery('#at_noti_options_alert_width').change(function() {
			jQuery('#at_noti_preview_content').css('width', jQuery('#at_noti_options_alert_width').val());
		});
		
		///////////////////////////////
		// Load all layers
		///////////////////////////////
		setTimeout(function() { jQuery('.at_noti_options_layer_type').change(); } , 1000);
		
		////////////////////////////////////
		// Open CSS editor
		////////////////////////////////////
		jQuery('#at_alert_css_styles').click(function() {
			jQuery('.at_half .row').hide();
			jQuery('.at_alert_styles_block').fadeIn();
		});
		jQuery('.at_css_editor').each(function() {
			jQuery(this).ace({ theme: 'crimson_editor', lang: 'css' });
			jQuery(this).parent().fadeOut(function() {
				at_designer_floater_offset = 	((jQuery('#wpadminbar').length) ? 40 : 12);
				at_designer_floater_top = 		jQuery('#at_noti_alert_designer_floater').offset().top;
				at_designer_floater_width = 	jQuery('#at_noti_alert_designer_floater').width();
				at_designer_floater_height = 	jQuery('#at_noti_alert_designer_floater').height();
			});
		});
		jQuery('#at_alert_css_styles_save').click(function() {
			jQuery('.at_half .row').fadeIn();
			jQuery('.at_alert_styles_block').hide();
		});
		
		/////////////////////////////////////
		// LOADEVENTS()
		/////////////////////////////////////
		var loadEvents = function() {
			if (at_noti_debug) console.log('triggered loadEvents');
			
			////////////////////////////////////////////////
			// Layer toggle expand/collapse
			////////////////////////////////////////////////
			jQuery('.layer_row:not(.active) .at_noti_options_layer_name').hide();
			jQuery('.at_noti_expand_layer_row').unbind('click');
			jQuery('.at_noti_expand_layer_row').click(function() {
				jQuery('.row.active .at_noti_options_layer_name').hide();
				jQuery('.row.active .at_noti_options_layer_name_caption').show();
				
				jQuery('.row.active').removeClass('active');
				jQuery('.at_noti_expand_layer_row.active').removeClass('active');
				
				var row = jQuery(this).closest('.row.layer_row');
				jQuery(this).toggleClass('active');
				row.toggleClass('active');
				
				row.find('.at_noti_options_layer_name').fadeIn();
				row.find('.at_noti_options_layer_name_caption').hide();
			});
			
			////////////////////////////////////////////////
			// Layer mouse events
			////////////////////////////////////////////////
			jQuery('.at_noti_preview_layer').unbind('mousewheel').unbind('click').unbind('dblclick');
			jQuery('.at_noti_preview_layer').draggable({
				drag: function(event, ui) {
					jQuery(this).css('border', 'dotted 1px #ccc').css('left', 'auto').css('right', 'auto');
					var id = jQuery(this).attr('id').replace('at_noti_preview_layer_', '');
					
					if (jQuery('#at_noti_options_layer_align_from_horiz_'+id).val() == 'left') {
						var coord_left = ui.position.left;
					}
					else {
						var coord_left = parseInt(jQuery('#at_noti_options_alert_width').val(),10) - ui.position.left - jQuery(this).width() - parseInt(jQuery('#at_noti_options_alert_layer_padding_'+id).val(), 10);
					}
					jQuery('#at_noti_options_alert_layer_x_'+id).val(coord_left);
					jQuery('#at_noti_options_alert_layer_y_'+id).val(ui.position.top);
				},
				stop: function() {
					jQuery(this).css('border', 'none');
				}
			
			}).bind('mousewheel', function(e){
				var id = jQuery(this).attr('id').replace('at_noti_preview_layer_', '');
				e.preventDefault();
				// change icon size with scroll wheel
				if(e.originalEvent.wheelDelta/120 > 0) {
					var newVal = parseInt(jQuery('#at_noti_options_alert_layer_size_'+id).val(), 10)+(e.shiftKey ? 10 : 1);
					jQuery('#at_noti_options_alert_layer_size_'+id).val(newVal);
				}
				else{
					var newVal = parseInt(jQuery('#at_noti_options_alert_layer_size_'+id).val(), 10)-(e.shiftKey ? 10 : 1);
					if (newVal < 0) { newVal = 0; }
					jQuery('#at_noti_options_alert_layer_size_'+id).val(newVal);
				}
				jQuery('#at_noti_preview_button').click();
			
			}).click(function() {
				var id = jQuery(this).attr('id').replace('at_noti_preview_layer_', '');
				jQuery('#at_layer_row_'+id).effect('highlight', 2000);
			
			}).dblclick(function() {
				jQuery('.row.active .at_noti_options_layer_name').hide();
				jQuery('.row.active .at_noti_options_layer_name_caption').show();
				
				jQuery('.layer_row.active').removeClass('active');
				jQuery('.at_noti_expand_layer_row.active').removeClass('active');
				
				var id = jQuery(this).attr('id').replace('at_noti_preview_layer_', '');
				jQuery('#expand_button_layer_'+id+':not(.active)').click();
				jQuery('#at_layer_row_'+id).stop(true, true).effect('highlight', 2000);
				jQuery(document).scrollTo(jQuery('#at_layer_row_'+id).position().top-at_designer_floater_height-at_designer_floater_offset+10, 600);
			});
			
			////////////////////////////////////////////////
			// Filter fields depending on Layer type
			////////////////////////////////////////////////
			jQuery('.at_noti_options_layer_type').unbind('change');
			jQuery('.at_noti_options_layer_type').change(function() {
				var row = jQuery(this).closest('.row.layer_row');
				row.find('.at_noti_filter_caption, .at_noti_filter_icon, .at_noti_filter_image, .at_noti_filter_button, .at_noti_filter_widget').hide();
				row.find('.at_noti_filter_'+jQuery(this).val()).show();
			});
			
			////////////////////////////////////
			// Delete icon button
			////////////////////////////////////
			jQuery('.at_noti_delete_layer_row').unbind('click');
			jQuery('.at_noti_delete_layer_row').click(function() {
				var id = parseInt(jQuery(this).attr('id').replace('delete_button_layer_', ''), 10);
				if (confirm('Are you sure you want to delete this layer?')) {
					jQuery('#at_layer_row_'+id).fadeOut(500, function() { jQuery(this).remove(); });
					jQuery('#at_noti_preview_layer_'+id).fadeOut(500, function() { jQuery(this).remove(); });
				}
			});
			
			//////////////////////////////////////////////////
			// Reload preview when form elements change
			//////////////////////////////////////////////////
			jQuery('.at_noti_options_layer_type').change(function() {
				var row = jQuery(this).closest('.row.layer_row');
				var id = row.attr('id').replace('at_layer_row_', '');
				reloadPreview(id);
			});
			
			jQuery('#at_noti_alert_metabox input, #at_noti_alert_metabox textarea').unbind('keyup').unbind('change');
			jQuery('#at_noti_alert_metabox input, #at_noti_alert_metabox textarea').keyup(function() {
				var row = jQuery(this).closest('.row.layer_row');
				if (row.attr('id')) {
					var id = row.attr('id').replace('at_layer_row_', '');
					reloadPreview(id);
				}
			}).change(function() { 
				var row = jQuery(this).closest('.row.layer_row');
				if (row.attr('id')) {
					var id = row.attr('id').replace('at_layer_row_', '');
					reloadPreview(id);
				}
			});
			jQuery('.at_noti_layer_row_content select').change(function() {
				var row = jQuery(this).closest('.row.layer_row');
				var id = row.attr('id').replace('at_layer_row_', '');
				reloadPreview(id);
			});
			
			
			///////////////////////////////////////////////
			// Layer name change
			///////////////////////////////////////////////
			jQuery('.at_noti_options_layer_name').unbind('keyup');
			jQuery('.at_noti_options_layer_name').keyup(function() {
				var row = jQuery(this).closest('.row.layer_row');
				row.find('.at_noti_options_layer_name_caption').html(jQuery(this).val());
			});
			
			////////////////////////////////////
			// Limit number-only inputs
			////////////////////////////////////
			//jQuery('input.num_only').unbind('mousewheel');
			jQuery('input.num_only').each(function() {
				var t = jQuery(this);
				t.keyup(function() {
					t.val(t.val().replace(/[^0-9\.]/g,''));
				}).bind('mousewheel', function(e){
					e.preventDefault();
					if(e.originalEvent.wheelDelta/120 > 0) {
						var newVal = parseInt(this.value, 10)+(e.shiftKey ? 10 : 1);
						this.value = newVal;
					}
					else{
						var newVal = parseInt(this.value, 10)-(e.shiftKey ? 10 : 1);
						this.value = newVal;
					}				
					var row = jQuery(this).closest('.row.layer_row');
					if (row.attr('id')) {
						var id = row.attr('id').replace('at_layer_row_', '');
						reloadPreview(id);
					}
				});
			});
			
			////////////////////////////////////
			// Load Fonts Select box
			////////////////////////////////////
			jQuery('.at_noti_options_layer_font:not(.font_loaded)').each(function() {
				var t = jQuery(this);
				t.addClass('font_loaded');
				
				t.fontselect().change(function() {
					var row = t.closest('.row.layer_row');
					var id = row.attr('id').replace('at_layer_row_', '');
					reloadPreview(id);
				});
				jQuery('.font-select').addClass('at_noti_filter_caption').addClass('at_noti_filter_button');
				
			});
			
			/////////////////////////////////////
			// Upload button
			/////////////////////////////////////
			jQuery('.at_noti_upload_image_button').click(function() {
				var t = jQuery(this);
				var id = jQuery(this).closest('.layer_row').attr('id').replace('at_layer_row_', '');
				media_button_id = id;
				
				// If the media frame already exists, reopen it.
				if ( file_frame ) {
					file_frame.open();
					return;
				}
				// Create the media frame.
				file_frame = wp.media.frames.file_frame = wp.media({
					title: jQuery( this ).data( 'uploader_title' ),
					button: {
						text: jQuery( this ).data( 'uploader_button_text' ),
					},
					multiple: false  // Set to true to allow multiple files to be selected
				});
				
				// When an image is selected, run a callback.
				file_frame.on( 'select', function() {
					// We set multiple to false so only get one image from the uploader
					attachment = file_frame.state().get('selection').first().toJSON();
					
					// Do something with attachment.id and/or attachment.url here
					//t.parent().find('.at_noti_options_alert_layer_img_url').val(attachment.url);
					jQuery('#at_layer_row_'+media_button_id).find('.at_noti_options_alert_layer_img_url').val(attachment.url);
					//var id = t.parent().find('.at_noti_options_alert_layer_img_url').attr('id').replace('at_noti_options_alert_layer_img_url_', '');
					reloadPreview(media_button_id);
				});
				
				// Finally, open the modal
				file_frame.open();
				
			});
			
			///////////////////////
			// Link Select
			///////////////////////
			jQuery('.at_noti_options_alert_icon_link').change(function() {
				var row = jQuery(this).closest('.row.layer_row');
				row.find('.at_noti_icon_link_options').css({'opacity': 1, 'visibility': 'visible'}).fadeIn();
			});
			
			//////////////////////
			// ColorPicker
			//////////////////////
			if( typeof jQuery.wp === 'object' && typeof jQuery.wp.wpColorPicker === 'function' ){
				jQuery('.color-picker').each(function() {
					var t = jQuery(this);
					t.wpColorPicker({
						change: function(event, uii) {
							var newColor = uii.color.toString();
							if (newColor.indexOf('#') === -1) {
								newColor = '#'+newColor;
							}
							
							//var targetField = jQuery(this).closest('.row.layer_row').find('.layer-color-picker');
							targetField = jQuery(this);
							jQuery(this).val(newColor);
							targetField.val(newColor);
							
							if (jQuery(this).hasClass('layer-color-picker')) {
								var id = jQuery(this).closest('.row.layer_row').attr('id').replace('at_layer_row_', '');
								reloadPreview(id);
							}
							else {
								reloadPreview('resize');
							}
						},
						clear: function(event) { 
							event.preventDefault();
							jQuery(this).parent().find('.color-picker').val('#FFFFFF').change(); 
							return false;
						}
					});
				});
			}
			else {
				jQuery('.color-picker').each(function() {
					var t = jQuery(this);
					
					t.iris({
						change: function(event, ui) {
							t.next().show();
							var newColor = ui.color.toString();
							if (newColor.indexOf('#') === -1) {
								newColor = '#'+newColor;
							}
							
							jQuery(this).val(newColor);
							if (jQuery(this).hasClass('layer-color-picker')) {
								var id = jQuery(this).closest('.row.layer_row').attr('id').replace('at_layer_row_', '');
								reloadPreview(id);
							}
							else {
								reloadPreview('resize');
							}
							
						}
					});
					
					jQuery('<span class="button button-primary button-close-iris">Close</span>').insertAfter(t);
					t.next().click(function() {
						t.iris('hide');
					});
					t.focus(function() {
						t.iris('show');
					});
					jQuery('.iris-picker').css({
						'margin-left': '206px'
					});
					
					
				});
			}
			
			///////////////////////////
			// Show/Hide layer 
			///////////////////////////
			jQuery('.at_noti_hide_layer').unbind('click');
			jQuery('.at_noti_hide_layer').click(function() {
					var row = jQuery(this).closest('.row.layer_row');
					var id = row.attr('id').replace('at_layer_row_', '');
					if (jQuery(this).hasClass('visible')) {
						jQuery(this).removeClass('visible').addClass('invisible').find('i').removeClass('icon-eye-open').addClass('icon-eye-close').css({'color': 'red'});
						jQuery('#at_noti_preview_layer_'+id).stop(true, true).fadeOut('fast');
					}
					else if (jQuery(this).hasClass('invisible')) {
						jQuery(this).removeClass('invisible').addClass('visible').find('i').removeClass('icon-eye-close').addClass('icon-eye-open').css({'color': '#333'});
						jQuery('#at_noti_preview_layer_'+id).stop(true, true).fadeIn('fast');
					}
			});
			
			///////////
			// END
			///////////
			if (at_noti_debug) console.log('end loadEvents');
		}
	
		loadEvents();
		
		jQuery('.at_noti_alert_metabox_layerlist .at_sortables').sortable();
		jQuery('.at_noti_options_alert_icon_link').change();
		
		
		
		
		
		
		jQuery('#at_noti_alert_metabox.postbox input, #at_noti_alert_metabox.postbox select').keyup(function() {
			reloadPreview('resize');
		}).change(function() { 
			reloadPreview('resize');
		}).bind('mousewheel', function(e){
			e.preventDefault(); 
			reloadPreview('resize');
		});
		
		///////////////////
		// Arrow keys 
		///////////////////
		jQuery('body').keydown(function (e) {
			if (jQuery(':focus').is('input, textarea, select')) { return; }
			
			if (jQuery('.layer_row.active').length) {
				var t = jQuery('.layer_row.active').eq(0);
				var id = t.attr('id').replace('at_layer_row_', '');
				
				var keyCode = e.keyCode || e.which,
				arrow = {left: 37, up: 38, right: 39, down: 40 };
				var anArrow = false;
				
				switch (keyCode) {
					case arrow.left:
						anArrow = true;
						if (jQuery('#at_noti_options_layer_align_from_horiz_'+id).val() == 'left') {
							jQuery('#at_noti_options_alert_layer_x_'+id).val(parseInt(jQuery('#at_noti_options_alert_layer_x_'+id).val(), 10) - (e.shiftKey ? 10 : 1));
						}
						else {
							jQuery('#at_noti_options_alert_layer_x_'+id).val(parseInt(jQuery('#at_noti_options_alert_layer_x_'+id).val(), 10) + (e.shiftKey ? 10 : 1));
						}
						break;
					case arrow.up:
						anArrow = true;
						jQuery('#at_noti_options_alert_layer_y_'+id).val(parseInt(jQuery('#at_noti_options_alert_layer_y_'+id).val(), 10) - (e.shiftKey ? 10 : 1));
						break;
					case arrow.right:
						anArrow = true;
						if (jQuery('#at_noti_options_layer_align_from_horiz_'+id).val() == 'left') {
							jQuery('#at_noti_options_alert_layer_x_'+id).val(parseInt(jQuery('#at_noti_options_alert_layer_x_'+id).val(), 10) + (e.shiftKey ? 10 : 1));
						}
						else {
							jQuery('#at_noti_options_alert_layer_x_'+id).val(parseInt(jQuery('#at_noti_options_alert_layer_x_'+id).val(), 10) - (e.shiftKey ? 10 : 1));
						}
						break;
					case arrow.down:
						anArrow = true;
						jQuery('#at_noti_options_alert_layer_y_'+id).val(parseInt(jQuery('#at_noti_options_alert_layer_y_'+id).val(), 10) + (e.shiftKey ? 10 : 1));
						break;
				}
				reloadPreview(id);
				
				if (anArrow == true) {
					e.preventDefault();
					return false;
				}
			}
		});
		
		// ------------------------------------------------------------------------------------------------------------- //
		
		
		
		// The following functions were moved down here
		// only because they are so long they annoyed me
		// to write the rest of the code.
		
		
		////////////////////////////////////
		// Add new layer button
		////////////////////////////////////
		jQuery('#at_noti_add_icon').click(function() {
			var iconArr = jQuery('.layer_row').map(function() {
				return parseInt(this.id.replace('at_layer_row_', ''), 10);
			});
			var maxNum = Math.max.apply(Math, iconArr);
			var newNum = maxNum + 1;
			
			jQuery('#at_noti_preview_content').append(' \
				<span class="at_noti_preview_layer" id="at_noti_preview_layer_'+newNum+'"> \
				</span> \
			');
			
			jQuery(' \
				<div class="row layer_row at_noti_container" id="at_layer_row_'+newNum+'"> \
					<input type="hidden"  class="at_noti_options_layer_id" name="at_noti_options[layers]['+newNum+'][id]" id="at_noti_options_layer_id_'+newNum+'" value="'+newNum+'" /> \
			 		\
					<!-- HEADING --> \
					<div class="at_noti_layer_row_heading"> \
			 		\
						<span class="at_noti_options_layer_name_caption">Layer #'+newNum+'</span> \
						<input type="text"  class="at_noti_options_layer_name" name="at_noti_options[layers]['+newNum+'][layer_name]" id="at_noti_options_layer_name_'+newNum+'" value="Layer #'+newNum+'" /> \
						 \
						<span class="inline-label">'+at_lang.layer_type+'</span> \
						<select class="at_noti_options_layer_type" name="at_noti_options[layers]['+newNum+'][layer_type]" id="at_noti_options_layer_type_'+newNum+'"> \
							<option value="caption">'+at_lang.caption+'</option> \
							<option value="icon">'+at_lang.icon+'</option> \
							<option value="image">'+at_lang.image+'</option> \
							<option value="button">'+at_lang.button+'</option> \
							<option value="widget">'+at_lang.widget_area+'</option> \
						</select> \
						 \
						<span class="button button-primary button-large at_noti_delete_layer_row at_noti_float_right" id="delete_button_layer_'+newNum+'"><i class="icon-remove"></i></span> \
						<span class="button button-primary button-large at_noti_expand_layer_row at_noti_float_right" id="expand_button_layer_'+newNum+'"><i class="icon-chevron-down"></i></span> \
						<span class="at_noti_float_right at_noti_hide_layer visible"><i class="icon-eye-open" title="'+at_lang.visible_invisible+'"></i></span> \
					 \
					</div> \
					<!-- / HEADING --> \
					 \
					<div class="at_clear"></div> \
					 \
					<div class="at_noti_layer_row_content"> \
						<div class="at_third"> \
							 \
							<!-- CAPTION --> \
							<div class="row 	at_noti_filter_caption"> \
								<label class="text_bold">'+at_lang.caption+'</label> \
								<textarea class="at_noti_options_layer_text" name="at_noti_options[layers]['+newNum+'][alert_layer_text]" id="at_noti_options_layer_text_'+newNum+'">'+at_lang.new_caption+'</textarea> \
								<div class="at_clear"></div> \
								<br /> \
								<label>&nbsp;</label><span class="notice" style="margin-top:30px;">'+at_lang.may_use_html+'</span> \
							</div> \
							 \
							<!-- ICON --> \
							<div class="row 	at_noti_filter_icon"> \
								<label class="text_bold">'+at_lang.icon+'</label> \
								<select id="at_noti_options_alert_icon_'+newNum+'" class="at_noti_options_alert_icon at_noti_filter_icon" name="at_noti_options[layers]['+newNum+'][alert_icon]"> \
									<option value="icon-glass">icon-glass</option> \
									<option value="icon-music">icon-music</option> \
									<option value="icon-search">icon-search</option> \
									<option value="icon-envelope-alt">icon-envelope-alt</option> \
									<option value="icon-heart">icon-heart</option> \
									<option value="icon-star">icon-star</option> \
									<option value="icon-star-empty">icon-star-empty</option> \
									<option value="icon-user">icon-user</option> \
									<option value="icon-film">icon-film</option> \
									<option value="icon-th-large">icon-th-large</option> \
									<option value="icon-th">icon-th</option> \
									<option value="icon-th-list">icon-th-list</option> \
									<option value="icon-ok">icon-ok</option> \
									<option value="icon-remove">icon-remove</option> \
									<option value="icon-zoom-in">icon-zoom-in</option> \
									<option value="icon-zoom-out">icon-zoom-out</option> \
									<option value="icon-power-off">icon-power-off</option> \
									<option value="icon-off">icon-off</option> \
									<option value="icon-signal">icon-signal</option> \
									<option value="icon-cog">icon-cog</option> \
									<option value="icon-trash">icon-trash</option> \
									<option value="icon-home">icon-home</option> \
									<option value="icon-file-alt">icon-file-alt</option> \
									<option value="icon-time">icon-time</option> \
									<option value="icon-road">icon-road</option> \
									<option value="icon-download-alt">icon-download-alt</option> \
									<option value="icon-download">icon-download</option> \
									<option value="icon-upload">icon-upload</option> \
									<option value="icon-inbox">icon-inbox</option> \
									<option value="icon-play-circle">icon-play-circle</option> \
									<option value="icon-rotate-right">icon-rotate-right</option> \
									<option value="icon-repeat">icon-repeat</option> \
									<option value="icon-refresh">icon-refresh</option> \
									<option value="icon-list-alt">icon-list-alt</option> \
									<option value="icon-lock">icon-lock</option> \
									<option value="icon-flag">icon-flag</option> \
									<option value="icon-headphones">icon-headphones</option> \
									<option value="icon-volume-off">icon-volume-off</option> \
									<option value="icon-volume-down">icon-volume-down</option> \
									<option value="icon-volume-up">icon-volume-up</option> \
									<option value="icon-qrcode">icon-qrcode</option> \
									<option value="icon-barcode">icon-barcode</option> \
									<option value="icon-tag">icon-tag</option> \
									<option value="icon-tags">icon-tags</option> \
									<option value="icon-book">icon-book</option> \
									<option value="icon-bookmark">icon-bookmark</option> \
									<option value="icon-print">icon-print</option> \
									<option value="icon-camera">icon-camera</option> \
									<option value="icon-font">icon-font</option> \
									<option value="icon-bold">icon-bold</option> \
									<option value="icon-italic">icon-italic</option> \
									<option value="icon-text-height">icon-text-height</option> \
									<option value="icon-text-width">icon-text-width</option> \
									<option value="icon-align-left">icon-align-left</option> \
									<option value="icon-align-center">icon-align-center</option> \
									<option value="icon-align-right">icon-align-right</option> \
									<option value="icon-align-justify">icon-align-justify</option> \
									<option value="icon-list">icon-list</option> \
									<option value="icon-indent-left">icon-indent-left</option> \
									<option value="icon-indent-right">icon-indent-right</option> \
									<option value="icon-facetime-video">icon-facetime-video</option> \
									<option value="icon-picture">icon-picture</option> \
									<option value="icon-pencil">icon-pencil</option> \
									<option value="icon-map-marker">icon-map-marker</option> \
									<option value="icon-adjust">icon-adjust</option> \
									<option value="icon-tint">icon-tint</option> \
									<option value="icon-edit">icon-edit</option> \
									<option value="icon-share">icon-share</option> \
									<option value="icon-check">icon-check</option> \
									<option value="icon-move">icon-move</option> \
									<option value="icon-step-backward">icon-step-backward</option> \
									<option value="icon-fast-backward">icon-fast-backward</option> \
									<option value="icon-backward">icon-backward</option> \
									<option value="icon-play">icon-play</option> \
									<option value="icon-pause">icon-pause</option> \
									<option value="icon-stop">icon-stop</option> \
									<option value="icon-forward">icon-forward</option> \
									<option value="icon-fast-forward">icon-fast-forward</option> \
									<option value="icon-step-forward">icon-step-forward</option> \
									<option value="icon-eject">icon-eject</option> \
									<option value="icon-chevron-left">icon-chevron-left</option> \
									<option value="icon-chevron-right">icon-chevron-right</option> \
									<option value="icon-plus-sign">icon-plus-sign</option> \
									<option value="icon-minus-sign">icon-minus-sign</option> \
									<option value="icon-remove-sign">icon-remove-sign</option> \
									<option value="icon-ok-sign">icon-ok-sign</option> \
									<option value="icon-question-sign">icon-question-sign</option> \
									<option value="icon-info-sign">icon-info-sign</option> \
									<option value="icon-screenshot">icon-screenshot</option> \
									<option value="icon-remove-circle">icon-remove-circle</option> \
									<option value="icon-ok-circle">icon-ok-circle</option> \
									<option value="icon-ban-circle">icon-ban-circle</option> \
									<option value="icon-arrow-left">icon-arrow-left</option> \
									<option value="icon-arrow-right">icon-arrow-right</option> \
									<option value="icon-arrow-up">icon-arrow-up</option> \
									<option value="icon-arrow-down">icon-arrow-down</option> \
									<option value="icon-mail-forward">icon-mail-forward</option> \
									<option value="icon-share-alt">icon-share-alt</option> \
									<option value="icon-resize-full">icon-resize-full</option> \
									<option value="icon-resize-small">icon-resize-small</option> \
									<option value="icon-plus">icon-plus</option> \
									<option value="icon-minus">icon-minus</option> \
									<option value="icon-asterisk">icon-asterisk</option> \
									<option value="icon-exclamation-sign">icon-exclamation-sign</option> \
									<option value="icon-gift">icon-gift</option> \
									<option value="icon-leaf">icon-leaf</option> \
									<option value="icon-fire">icon-fire</option> \
									<option value="icon-eye-open">icon-eye-open</option> \
									<option value="icon-eye-close">icon-eye-close</option> \
									<option value="icon-warning-sign">icon-warning-sign</option> \
									<option value="icon-plane">icon-plane</option> \
									<option value="icon-calendar">icon-calendar</option> \
									<option value="icon-random">icon-random</option> \
									<option value="icon-comment">icon-comment</option> \
									<option value="icon-magnet">icon-magnet</option> \
									<option value="icon-chevron-up">icon-chevron-up</option> \
									<option value="icon-chevron-down">icon-chevron-down</option> \
									<option value="icon-retweet">icon-retweet</option> \
									<option value="icon-shopping-cart">icon-shopping-cart</option> \
									<option value="icon-folder-close">icon-folder-close</option> \
									<option value="icon-folder-open">icon-folder-open</option> \
									<option value="icon-resize-vertical">icon-resize-vertical</option> \
									<option value="icon-resize-horizontal">icon-resize-horizontal</option> \
									<option value="icon-bar-chart">icon-bar-chart</option> \
									<option value="icon-twitter-sign">icon-twitter-sign</option> \
									<option value="icon-facebook-sign">icon-facebook-sign</option> \
									<option value="icon-camera-retro">icon-camera-retro</option> \
									<option value="icon-key">icon-key</option> \
									<option value="icon-cogs">icon-cogs</option> \
									<option value="icon-comments">icon-comments</option> \
									<option value="icon-thumbs-up-alt">icon-thumbs-up-alt</option> \
									<option value="icon-thumbs-down-alt">icon-thumbs-down-alt</option> \
									<option value="icon-star-half">icon-star-half</option> \
									<option value="icon-heart-empty">icon-heart-empty</option> \
									<option value="icon-signout">icon-signout</option> \
									<option value="icon-linkedin-sign">icon-linkedin-sign</option> \
									<option value="icon-pushpin">icon-pushpin</option> \
									<option value="icon-external-link">icon-external-link</option> \
									<option value="icon-signin">icon-signin</option> \
									<option value="icon-trophy">icon-trophy</option> \
									<option value="icon-github-sign">icon-github-sign</option> \
									<option value="icon-upload-alt">icon-upload-alt</option> \
									<option value="icon-lemon">icon-lemon</option> \
									<option value="icon-phone">icon-phone</option> \
									<option value="icon-unchecked">icon-unchecked</option> \
									<option value="icon-check-empty">icon-check-empty</option> \
									<option value="icon-bookmark-empty">icon-bookmark-empty</option> \
									<option value="icon-phone-sign">icon-phone-sign</option> \
									<option value="icon-twitter">icon-twitter</option> \
									<option value="icon-facebook">icon-facebook</option> \
									<option value="icon-github">icon-github</option> \
									<option value="icon-unlock">icon-unlock</option> \
									<option value="icon-credit-card">icon-credit-card</option> \
									<option value="icon-rss">icon-rss</option> \
									<option value="icon-hdd">icon-hdd</option> \
									<option value="icon-bullhorn">icon-bullhorn</option> \
									<option value="icon-bell">icon-bell</option> \
									<option value="icon-certificate">icon-certificate</option> \
									<option value="icon-hand-right">icon-hand-right</option> \
									<option value="icon-hand-left">icon-hand-left</option> \
									<option value="icon-hand-up">icon-hand-up</option> \
									<option value="icon-hand-down">icon-hand-down</option> \
									<option value="icon-circle-arrow-left">icon-circle-arrow-left</option> \
									<option value="icon-circle-arrow-right">icon-circle-arrow-right</option> \
									<option value="icon-circle-arrow-up">icon-circle-arrow-up</option> \
									<option value="icon-circle-arrow-down">icon-circle-arrow-down</option> \
									<option value="icon-globe">icon-globe</option> \
									<option value="icon-wrench">icon-wrench</option> \
									<option value="icon-tasks">icon-tasks</option> \
									<option value="icon-filter">icon-filter</option> \
									<option value="icon-briefcase">icon-briefcase</option> \
									<option value="icon-fullscreen">icon-fullscreen</option> \
									<option value="icon-group">icon-group</option> \
									<option value="icon-link">icon-link</option> \
									<option value="icon-cloud">icon-cloud</option> \
									<option value="icon-beaker">icon-beaker</option> \
									<option value="icon-cut">icon-cut</option> \
									<option value="icon-copy">icon-copy</option> \
									<option value="icon-paperclip">icon-paperclip</option> \
									<option value="icon-paper-clip">icon-paper-clip</option> \
									<option value="icon-save">icon-save</option> \
									<option value="icon-sign-blank">icon-sign-blank</option> \
									<option value="icon-reorder">icon-reorder</option> \
									<option value="icon-list-ul">icon-list-ul</option> \
									<option value="icon-list-ol">icon-list-ol</option> \
									<option value="icon-strikethrough">icon-strikethrough</option> \
									<option value="icon-underline">icon-underline</option> \
									<option value="icon-table">icon-table</option> \
									<option value="icon-magic">icon-magic</option> \
									<option value="icon-truck">icon-truck</option> \
									<option value="icon-pinterest">icon-pinterest</option> \
									<option value="icon-pinterest-sign">icon-pinterest-sign</option> \
									<option value="icon-google-plus-sign">icon-google-plus-sign</option> \
									<option value="icon-google-plus">icon-google-plus</option> \
									<option value="icon-money">icon-money</option> \
									<option value="icon-caret-down">icon-caret-down</option> \
									<option value="icon-caret-up">icon-caret-up</option> \
									<option value="icon-caret-left">icon-caret-left</option> \
									<option value="icon-caret-right">icon-caret-right</option> \
									<option value="icon-columns">icon-columns</option> \
									<option value="icon-sort">icon-sort</option> \
									<option value="icon-sort-down">icon-sort-down</option> \
									<option value="icon-sort-up">icon-sort-up</option> \
									<option value="icon-envelope">icon-envelope</option> \
									<option value="icon-linkedin">icon-linkedin</option> \
									<option value="icon-rotate-left">icon-rotate-left</option> \
									<option value="icon-undo">icon-undo</option> \
									<option value="icon-legal">icon-legal</option> \
									<option value="icon-dashboard">icon-dashboard</option> \
									<option value="icon-comment-alt">icon-comment-alt</option> \
									<option value="icon-comments-alt">icon-comments-alt</option> \
									<option value="icon-bolt">icon-bolt</option> \
									<option value="icon-sitemap">icon-sitemap</option> \
									<option value="icon-umbrella">icon-umbrella</option> \
									<option value="icon-paste">icon-paste</option> \
									<option value="icon-lightbulb">icon-lightbulb</option> \
									<option value="icon-exchange">icon-exchange</option> \
									<option value="icon-cloud-download">icon-cloud-download</option> \
									<option value="icon-cloud-upload">icon-cloud-upload</option> \
									<option value="icon-user-md">icon-user-md</option> \
									<option value="icon-stethoscope">icon-stethoscope</option> \
									<option value="icon-suitcase">icon-suitcase</option> \
									<option value="icon-bell-alt">icon-bell-alt</option> \
									<option value="icon-coffee">icon-coffee</option> \
									<option value="icon-food">icon-food</option> \
									<option value="icon-file-text-alt">icon-file-text-alt</option> \
									<option value="icon-building">icon-building</option> \
									<option value="icon-hospital">icon-hospital</option> \
									<option value="icon-ambulance">icon-ambulance</option> \
									<option value="icon-medkit">icon-medkit</option> \
									<option value="icon-fighter-jet">icon-fighter-jet</option> \
									<option value="icon-beer">icon-beer</option> \
									<option value="icon-h-sign">icon-h-sign</option> \
									<option value="icon-plus-sign-alt">icon-plus-sign-alt</option> \
									<option value="icon-double-angle-left">icon-double-angle-left</option> \
									<option value="icon-double-angle-right">icon-double-angle-right</option> \
									<option value="icon-double-angle-up">icon-double-angle-up</option> \
									<option value="icon-double-angle-down">icon-double-angle-down</option> \
									<option value="icon-angle-left">icon-angle-left</option> \
									<option value="icon-angle-right">icon-angle-right</option> \
									<option value="icon-angle-up">icon-angle-up</option> \
									<option value="icon-angle-down">icon-angle-down</option> \
									<option value="icon-desktop">icon-desktop</option> \
									<option value="icon-laptop">icon-laptop</option> \
									<option value="icon-tablet">icon-tablet</option> \
									<option value="icon-mobile-phone">icon-mobile-phone</option> \
									<option value="icon-circle-blank">icon-circle-blank</option> \
									<option value="icon-quote-left">icon-quote-left</option> \
									<option value="icon-quote-right">icon-quote-right</option> \
									<option value="icon-spinner">icon-spinner</option> \
									<option value="icon-circle">icon-circle</option> \
									<option value="icon-mail-reply">icon-mail-reply</option> \
									<option value="icon-reply">icon-reply</option> \
									<option value="icon-github-alt">icon-github-alt</option> \
									<option value="icon-folder-close-alt">icon-folder-close-alt</option> \
									<option value="icon-folder-open-alt">icon-folder-open-alt</option> \
									<option value="icon-expand-alt">icon-expand-alt</option> \
									<option value="icon-collapse-alt">icon-collapse-alt</option> \
									<option value="icon-smile">icon-smile</option> \
									<option value="icon-frown">icon-frown</option> \
									<option value="icon-meh">icon-meh</option> \
									<option value="icon-gamepad">icon-gamepad</option> \
									<option value="icon-keyboard">icon-keyboard</option> \
									<option value="icon-flag-alt">icon-flag-alt</option> \
									<option value="icon-flag-checkered">icon-flag-checkered</option> \
									<option value="icon-terminal">icon-terminal</option> \
									<option value="icon-code">icon-code</option> \
									<option value="icon-reply-all">icon-reply-all</option> \
									<option value="icon-mail-reply-all">icon-mail-reply-all</option> \
									<option value="icon-star-half-full">icon-star-half-full</option> \
									<option value="icon-star-half-empty">icon-star-half-empty</option> \
									<option value="icon-location-arrow">icon-location-arrow</option> \
									<option value="icon-crop">icon-crop</option> \
									<option value="icon-code-fork">icon-code-fork</option> \
									<option value="icon-unlink">icon-unlink</option> \
									<option value="icon-question">icon-question</option> \
									<option value="icon-info">icon-info</option> \
									<option value="icon-exclamation">icon-exclamation</option> \
									<option value="icon-superscript">icon-superscript</option> \
									<option value="icon-subscript">icon-subscript</option> \
									<option value="icon-eraser">icon-eraser</option> \
									<option value="icon-puzzle-piece">icon-puzzle-piece</option> \
									<option value="icon-microphone">icon-microphone</option> \
									<option value="icon-microphone-off">icon-microphone-off</option> \
									<option value="icon-shield">icon-shield</option> \
									<option value="icon-calendar-empty">icon-calendar-empty</option> \
									<option value="icon-fire-extinguisher">icon-fire-extinguisher</option> \
									<option value="icon-rocket">icon-rocket</option> \
									<option value="icon-maxcdn">icon-maxcdn</option> \
									<option value="icon-chevron-sign-left">icon-chevron-sign-left</option> \
									<option value="icon-chevron-sign-right">icon-chevron-sign-right</option> \
									<option value="icon-chevron-sign-up">icon-chevron-sign-up</option> \
									<option value="icon-chevron-sign-down">icon-chevron-sign-down</option> \
									<option value="icon-html5">icon-html5</option> \
									<option value="icon-css3">icon-css3</option> \
									<option value="icon-anchor">icon-anchor</option> \
									<option value="icon-unlock-alt">icon-unlock-alt</option> \
									<option value="icon-bullseye">icon-bullseye</option> \
									<option value="icon-ellipsis-horizontal">icon-ellipsis-horizontal</option> \
									<option value="icon-ellipsis-vertical">icon-ellipsis-vertical</option> \
									<option value="icon-rss-sign">icon-rss-sign</option> \
									<option value="icon-play-sign">icon-play-sign</option> \
									<option value="icon-ticket">icon-ticket</option> \
									<option value="icon-minus-sign-alt">icon-minus-sign-alt</option> \
									<option value="icon-check-minus">icon-check-minus</option> \
									<option value="icon-level-up">icon-level-up</option> \
									<option value="icon-level-down">icon-level-down</option> \
									<option value="icon-check-sign">icon-check-sign</option> \
									<option value="icon-edit-sign">icon-edit-sign</option> \
									<option value="icon-external-link-sign">icon-external-link-sign</option> \
									<option value="icon-share-sign">icon-share-sign</option> \
									<option value="icon-compass">icon-compass</option> \
									<option value="icon-collapse">icon-collapse</option> \
									<option value="icon-collapse-top">icon-collapse-top</option> \
									<option value="icon-expand">icon-expand</option> \
									<option value="icon-euro">icon-euro</option> \
									<option value="icon-eur">icon-eur</option> \
									<option value="icon-gbp">icon-gbp</option> \
									<option value="icon-dollar">icon-dollar</option> \
									<option value="icon-usd">icon-usd</option> \
									<option value="icon-rupee">icon-rupee</option> \
									<option value="icon-inr">icon-inr</option> \
									<option value="icon-yen">icon-yen</option> \
									<option value="icon-jpy">icon-jpy</option> \
									<option value="icon-renminbi">icon-renminbi</option> \
									<option value="icon-cny">icon-cny</option> \
									<option value="icon-won">icon-won</option> \
									<option value="icon-krw">icon-krw</option> \
									<option value="icon-bitcoin">icon-bitcoin</option> \
									<option value="icon-btc">icon-btc</option> \
									<option value="icon-file">icon-file</option> \
									<option value="icon-file-text">icon-file-text</option> \
									<option value="icon-sort-by-alphabet">icon-sort-by-alphabet</option> \
									<option value="icon-sort-by-alphabet-alt">icon-sort-by-alphabet-alt</option> \
									<option value="icon-sort-by-attributes">icon-sort-by-attributes</option> \
									<option value="icon-sort-by-attributes-alt">icon-sort-by-attributes-alt</option> \
									<option value="icon-sort-by-order">icon-sort-by-order</option> \
									<option value="icon-sort-by-order-alt">icon-sort-by-order-alt</option> \
									<option value="icon-thumbs-up">icon-thumbs-up</option> \
									<option value="icon-thumbs-down">icon-thumbs-down</option> \
									<option value="icon-youtube-sign">icon-youtube-sign</option> \
									<option value="icon-youtube">icon-youtube</option> \
									<option value="icon-xing">icon-xing</option> \
									<option value="icon-xing-sign">icon-xing-sign</option> \
									<option value="icon-youtube-play">icon-youtube-play</option> \
									<option value="icon-dropbox">icon-dropbox</option> \
									<option value="icon-stackexchange">icon-stackexchange</option> \
									<option value="icon-instagram">icon-instagram</option> \
									<option value="icon-flickr">icon-flickr</option> \
									<option value="icon-adn">icon-adn</option> \
									<option value="icon-bitbucket">icon-bitbucket</option> \
									<option value="icon-bitbucket-sign">icon-bitbucket-sign</option> \
									<option value="icon-tumblr">icon-tumblr</option> \
									<option value="icon-tumblr-sign">icon-tumblr-sign</option> \
									<option value="icon-long-arrow-down">icon-long-arrow-down</option> \
									<option value="icon-long-arrow-up">icon-long-arrow-up</option> \
									<option value="icon-long-arrow-left">icon-long-arrow-left</option> \
									<option value="icon-long-arrow-right">icon-long-arrow-right</option> \
									<option value="icon-apple">icon-apple</option> \
									<option value="icon-windows">icon-windows</option> \
									<option value="icon-android">icon-android</option> \
									<option value="icon-linux">icon-linux</option> \
									<option value="icon-dribble">icon-dribble</option> \
									<option value="icon-skype">icon-skype</option> \
									<option value="icon-foursquare">icon-foursquare</option> \
									<option value="icon-trello">icon-trello</option> \
									<option value="icon-female">icon-female</option> \
									<option value="icon-male">icon-male</option> \
									<option value="icon-gittip">icon-gittip</option> \
									<option value="icon-sun">icon-sun</option> \
									<option value="icon-moon">icon-moon</option> \
									<option value="icon-archive">icon-archive</option> \
									<option value="icon-bug">icon-bug</option> \
									<option value="icon-vk">icon-vk</option> \
									<option value="icon-weibo">icon-weibo</option> \
									<option value="icon-renren">icon-renren</option> \
								</select> \
							</div> \
							 \
							<!-- BUTTON --> \
							<div class="row 	at_noti_filter_button"> \
								<label class="text_bold">'+at_lang.button_text+'</label> \
								<input type="text" class="at_noti_options_alert_layer_btn_caption at_noti_filter_button" name="at_noti_options[layers]['+newNum+'][alert_layer_btn_caption]" id="at_noti_options_alert_layer_btn_caption_'+newNum+'" value="'+at_lang.click_me+'" /> \
							</div> \
							 \
							<!-- FONT --> \
							<div class="row 	at_noti_filter_caption at_noti_filter_button"> \
								<label class="text_bold">'+at_lang.font+'</label> \
								<input type="text" class="at_noti_options_layer_font" name="at_noti_options[layers]['+newNum+'][alert_layer_font]" id="at_noti_options_layer_font_'+newNum+'" value=""> \
							</div> \
							 \
							<!-- SIZE + COLOR --> \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button"> \
								<label class="text_bold">'+at_lang.size+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_size num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_size]" id="at_noti_options_alert_layer_size_'+newNum+'" value="30" /> px \
							</div> \
							 \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button"> \
								<label class="text_bold">'+at_lang.color+'</label> \
								<input type="text" class="at_noti_options_alert_layer_color color-picker layer-color-picker" name="at_noti_options[layers]['+newNum+'][alert_layer_color]" id="at_noti_options_alert_layer_color_'+newNum+'" value="#000000" /> \
							</div> \
							 \
							<div class="row 	at_noti_filter_button"> \
								<label class="text_bold">'+at_lang.color+' : HOVER</label> \
								<input type="text" class="at_noti_options_alert_icon_link_hover color-picker layer-color-picker" name="at_noti_options[layers]['+newNum+'][alert_icon_link_hover]" id="at_noti_options_alert_icon_link_hover_'+newNum+'" value="#000000" /> \
							</div> \
							 \
							<div class="row 	at_noti_filter_button"> \
								<label class="text_bold">'+at_lang.background+'</label> \
								<input type="text" class="at_noti_options_alert_layer_color_btn_background color-picker layer-color-picker" name="at_noti_options[layers]['+newNum+'][alert_layer_color_btn_background]" id="at_noti_options_alert_layer_color_btn_background_'+newNum+'" value="#FFFFFF" /> \
							</div> \
							 \
							<div class="row 	at_noti_filter_button"> \
								<label class="text_bold">'+at_lang.background+' : HOVER</label> \
								<input type="text" class="at_noti_options_alert_icon_link_hover_background_btn color-picker layer-color-picker" name="at_noti_options[layers]['+newNum+'][alert_icon_link_hover_background_btn]" id="at_noti_options_alert_icon_link_hover_background_btn_'+newNum+'" value="#FFFFFF" /> \
							</div>                 \
							 \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button"> \
								<label class="text_bold">'+at_lang.line_height+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_line_height num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_line_height]" id="at_noti_options_alert_layer_line_height_'+newNum+'" value="32" /> px \
							</div> \
							 \
							<!-- IMAGE STUFF --> \
							<div class="row 	at_noti_filter_image"> \
								<label class="text_bold">'+at_lang.image+'</label> \
								<input type="text" class="at_noti_options_alert_layer_img_url num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_img_url]" id="at_noti_options_alert_layer_img_url_'+newNum+'" value="http://" /> \
								<span class="at_noti_upload_image_button button button-secondary">Select file</span> \
							</div> \
							 \
							<div class="row 	at_noti_filter_image at_noti_filter_widget"> \
								<label class="text_bold">'+at_lang.width+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_w num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_w]" id="at_noti_options_alert_layer_w_'+newNum+'" value="100" /> px \
							</div> \
							 \
							<div class="row 	at_noti_filter_image at_noti_filter_widget"> \
								<label class="text_bold">'+at_lang.height+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_h num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_h]" id="at_noti_options_alert_layer_h_'+newNum+'" value="" /> px \
							</div> \
							 \
							<div class="row 	at_noti_filter_button"> \
								<label class="text_bold">'+at_lang.padding+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_padding num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_padding]" id="at_noti_options_alert_layer_padding_'+newNum+'" value="15" /> px \
							</div>  \
							 \
							<div class="row 	at_noti_filter_button"> \
								<label class="text_bold">'+at_lang.border_radius+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_border_radius num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_border_radius]" id="at_noti_options_alert_layer_border_radius_'+newNum+'" value="4" /> px \
							</div> \
							 \
							<div class="row 	at_noti_filter_image at_noti_filter_icon"> \
								<label class="text_bold">'+at_lang.link+'</label> \
								<select id="at_noti_options_alert_icon_link_'+newNum+'" class="at_noti_options_alert_icon_link" name="at_noti_options[layers]['+newNum+'][alert_icon_link]"> \
									<option value="">'+at_lang.no+'</option> \
									<option value="1">'+at_lang.yes+'</option> \
								</select> \
							</div> \
							 \
							<div class="row 	at_noti_filter_button at_noti_filter_image at_noti_filter_icon"> \
								<label class="text_bold">'+at_lang.link_url+'</label> \
								<input type="text" class="at_noti_options_alert_icon_link_url" name="at_noti_options[layers]['+newNum+'][alert_icon_link_url]" id="at_noti_options_alert_icon_link_url_'+newNum+'" value="http://" /> \
								<select class="at_noti_options_alert_icon_link_target" name="at_noti_options[layers]['+newNum+'][alert_icon_link_target]" id="at_noti_options_alert_icon_link_target_'+newNum+'"> \
									<option value="">default</option> \
									<option value="_blank">_blank</option> \
									<option value="_new">_new</option> \
									<option value="_parent">_parent</option> \
									<option value="_self">_self</option> \
									<option value="_top">_top</option> \
								</select> \
							</div> \
								 \
						</div> \
						 \
						 \
						<div class="at_third"> \
							 \
							<!-- LOAD ANIMATION --> \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label class="text_bold">'+at_lang.load_animation+'</label> \
								<select name="at_noti_options[layers]['+newNum+'][alert_layer_entrance_anim]"> \
									<option value="">disabled</option> \
									<option value="fadeIn">fadeIn</option> \
									<option value="fadeInUp">fadeInUp</option> \
									<option value="fadeInDown">fadeInDown</option> \
									<option value="fadeInLeft">fadeInLeft</option> \
									<option value="fadeInRight">fadeInRight</option> \
									<option value="fadeInLeftBig">fadeInLeftBig</option> \
									<option value="fadeInRightBig">fadeInRightBig</option> \
									<option value="bounceInDown">bounceInDown</option> \
									<option value="bounceInUp">bounceInUp</option> \
									<option value="bounceInLeft">bounceInLeft</option> \
									<option value="bounceInRight">bounceInRight</option> \
								</select> \
							</div> \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label>'+at_lang.delay+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_entrance_anim_delay num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_entrance_anim_delay]" id="at_noti_options_alert_layer_entrance_anim_delay_'+newNum+'" value="0" /> ms \
							</div> \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label>'+at_lang.speed+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_entrance_anim_speed num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_entrance_anim_speed]" id="at_noti_options_alert_layer_entrance_anim_speed_'+newNum+'" value="0" /> ms \
							</div> \
							 \
							<!-- UNLOAD ANIMATION --> \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label class="text_bold">'+at_lang.unload_animation+'</label> \
								<select name="at_noti_options[layers]['+newNum+'][alert_layer_exit_anim]"> \
									<option value="">disabled</option> \
									<option value="fadeOut">fadeOut</option> \
									<option value="fadeOutUp">fadeOutUp</option> \
									<option value="fadeOutDown">fadeOutDown</option> \
									<option value="fadeOutLeft">fadeOutLeft</option> \
									<option value="fadeOutRight">fadeOutRight</option> \
									<option value="fadeOutLeftBig">fadeOutLeftBig</option> \
									<option value="fadeOutRightBig">fadeOutRightBig</option> \
									<option value="bounceOutDown">bounceOutDown</option> \
									<option value="bounceOutUp">bounceOutUp</option> \
									<option value="bounceOutLeft">bounceOutLeft</option> \
									<option value="bounceOutRight">bounceOutRight</option> \
								</select> \
							</div> \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label>'+at_lang.delay+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_exit_anim_delay num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_exit_anim_delay]" id="at_noti_options_alert_layer_exit_anim_delay_'+newNum+'" value="0" /> ms \
							</div> \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label>'+at_lang.speed+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_exit_anim_speed num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_exit_anim_speed]" id="at_noti_options_alert_layer_exit_anim_speed_'+newNum+'" value="0" /> ms \
							</div> \
								 \
						</div> \
						 \
						 \
						<div class="at_third"> \
							 \
							<!-- POSITION --> \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label class="text_bold">'+at_lang.alignment+'</label> \
								<select name="at_noti_options[layers]['+newNum+'][alert_align_from_horiz]" id="at_noti_options_layer_align_from_horiz_'+newNum+'"> \
									<option value="left">'+at_lang.from_left+'</option> \
									<option value="right">'+at_lang.from_right+'</option> \
								</select> \
							</div> \
							 \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label class="text_bold">'+at_lang.position_x+' (<span class="at_noti_aligntment_hint"></span>)</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_x num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_x]" id="at_noti_options_alert_layer_x_'+newNum+'" value="0" /> px \
							</div> \
							 \
							<div class="row at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label class="text_bold">'+at_lang.position_y+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_y num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_y]" id="at_noti_options_alert_layer_y_'+newNum+'" value="0" /> px \
							</div> \
							 \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label class="text_bold">'+at_lang.z_index+'</label> \
								<input type="text" class="tiny at_noti_options_alert_layer_z num_only" name="at_noti_options[layers]['+newNum+'][alert_layer_z]" id="at_noti_options_alert_layer_z_'+newNum+'" value="0" /> \
							</div> \
							 \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label class="text_bold">'+at_lang.custom_class+'</label> \
								<input type="text" class="at_noti_options_alert_layer_css_class" name="at_noti_options[layers]['+newNum+'][alert_layer_css_class]" id="at_noti_options_alert_layer_css_class_'+newNum+'" value="" /> \
							</div> \
							 \
							<div class="row 	at_noti_filter_caption at_noti_filter_icon at_noti_filter_button at_noti_filter_image at_noti_filter_widget"> \
								<label class="text_bold">'+at_lang.inline_styles+'</label> \
								<input type="text" class="at_noti_options_alert_layer_css_inline" name="at_noti_options[layers]['+newNum+'][alert_layer_css_inline]" id="at_noti_options_alert_layer_css_inline_'+newNum+'" value="" /> \
							</div> \
							 \
						</div> \
						 \
						<div class="at_clear"></div> \
					</div> \
				</div> \
			').insertAfter(jQuery('#at_layers_list_block .layer_row').last());
			
			jQuery('#at_layer_row_'+newNum).fadeIn(function() {
				loadEvents();
				reloadPreview(newNum);
				jQuery(this).find('.at_noti_options_layer_type').change();
				jQuery('.at_noti_alert_metabox_layerlist').sortable();
				jQuery(this).find('.at_noti_expand_layer_row').click();
			});
			
		});
	
	}
	
});